package com.huimv.receive.timer;


import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.receive.entity.BillIsolate;
import com.huimv.receive.entity.SysUser;
import com.huimv.receive.entity.BillPcr;
import com.huimv.receive.service.IBillIsolateService;
import com.huimv.receive.service.IBillPcrService;
import com.huimv.receive.service.ISysUserService;
import com.huimv.receive.service.IConfigurationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.List;

@Configuration
@EnableScheduling
public class SafeTimer {


    @Autowired
    private IBillPcrService pcrService;
    @Autowired
    private IBillIsolateService isolateService;
    @Autowired
    private IConfigurationService configurationService;

    @Autowired
    private ISysUserService sysUserService;


    @Scheduled(cron = "0 0/1 * * * ? ")
    private void getShenChan() throws Exception {
        QueryWrapper<BillIsolate> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("bill_status", 1);
        List<BillIsolate> isolates = isolateService.list(queryWrapper);
        Date date = new Date();
        for (BillIsolate isolate : isolates) {
            if (isolate.getIsolateEndDate().getTime() <= date.getTime()) {
                isolate.setIsolateRealEndDate(date);
                isolate.setIsolateRealDayNum(isolate.getIsolateDayNum());
                isolate.setBillStatus(2);
                isolate.setPassUserName("自然解除隔离");
                isolate.setPassDate(date);
                isolateService.updateById(isolate);
            }
        }
    }

    @Scheduled(cron = "0 0/1 * * * ? ")
    private void pcr() throws Exception {
        QueryWrapper<BillPcr> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("bill_status", 1);
        List<BillPcr> pcrs = pcrService.list(queryWrapper);
        Date date = new Date();
        for (BillPcr pcr : pcrs) {
            Date subDate = pcr.getCheckDate();
            // 将LocalDateTime转换为Date

            if ((subDate.getTime() + pcr.getQualifiedDate() * 60 * 60 * 1000) <= date.getTime()) {
                pcr.setBillStatus(3);
                pcrService.updateById(pcr);
            }
        }
    }

    //计算年龄
    @Scheduled(cron = "0 0 0 * * ? ")
    private void getAge()   {
        System.out.println("开始");
        List<SysUser> sysUsers = sysUserService.list();
        for (SysUser sysUser : sysUsers) {
            int i = DateUtil.ageOfNow(sysUser.getBirthday());
            if (i !=sysUser.getAge() ){
                sysUser.setAge(i);
                sysUserService.updateById(sysUser);
            }
        }
    }

}
